/* LCM type definition class file
 * This file was automatically generated by lcm-gen
 * DO NOT MODIFY BY HAND!!!!
 */

package gps_package;
 
import java.io.*;
import java.util.*;
import lcm.lcm.*;
 
public final class gps_t implements lcm.lcm.LCMEncodable
{
    public float timestamp;
    public float lat;
    public String latdir;
    public float lon;
    public String londir;
    public float altitude;
    public float eastings;
    public float northings;
 
    public gps_t()
    {
    }
 
    public static final long LCM_FINGERPRINT;
    public static final long LCM_FINGERPRINT_BASE = 0xc851d55116a0d2d3L;
 
    static {
        LCM_FINGERPRINT = _hashRecursive(new ArrayList<Class<?>>());
    }
 
    public static long _hashRecursive(ArrayList<Class<?>> classes)
    {
        if (classes.contains(gps_package.gps_t.class))
            return 0L;
 
        classes.add(gps_package.gps_t.class);
        long hash = LCM_FINGERPRINT_BASE
            ;
        classes.remove(classes.size() - 1);
        return (hash<<1) + ((hash>>63)&1);
    }
 
    public void encode(DataOutput outs) throws IOException
    {
        outs.writeLong(LCM_FINGERPRINT);
        _encodeRecursive(outs);
    }
 
    public void _encodeRecursive(DataOutput outs) throws IOException
    {
        char[] __strbuf = null;
        outs.writeFloat(this.timestamp); 
 
        outs.writeFloat(this.lat); 
 
        __strbuf = new char[this.latdir.length()]; this.latdir.getChars(0, this.latdir.length(), __strbuf, 0); outs.writeInt(__strbuf.length+1); for (int _i = 0; _i < __strbuf.length; _i++) outs.write(__strbuf[_i]); outs.writeByte(0); 
 
        outs.writeFloat(this.lon); 
 
        __strbuf = new char[this.londir.length()]; this.londir.getChars(0, this.londir.length(), __strbuf, 0); outs.writeInt(__strbuf.length+1); for (int _i = 0; _i < __strbuf.length; _i++) outs.write(__strbuf[_i]); outs.writeByte(0); 
 
        outs.writeFloat(this.altitude); 
 
        outs.writeFloat(this.eastings); 
 
        outs.writeFloat(this.northings); 
 
    }
 
    public gps_t(byte[] data) throws IOException
    {
        this(new LCMDataInputStream(data));
    }
 
    public gps_t(DataInput ins) throws IOException
    {
        if (ins.readLong() != LCM_FINGERPRINT)
            throw new IOException("LCM Decode error: bad fingerprint");
 
        _decodeRecursive(ins);
    }
 
    public static gps_package.gps_t _decodeRecursiveFactory(DataInput ins) throws IOException
    {
        gps_package.gps_t o = new gps_package.gps_t();
        o._decodeRecursive(ins);
        return o;
    }
 
    public void _decodeRecursive(DataInput ins) throws IOException
    {
        char[] __strbuf = null;
        this.timestamp = ins.readFloat();
 
        this.lat = ins.readFloat();
 
        __strbuf = new char[ins.readInt()-1]; for (int _i = 0; _i < __strbuf.length; _i++) __strbuf[_i] = (char) (ins.readByte()&0xff); ins.readByte(); this.latdir = new String(__strbuf);
 
        this.lon = ins.readFloat();
 
        __strbuf = new char[ins.readInt()-1]; for (int _i = 0; _i < __strbuf.length; _i++) __strbuf[_i] = (char) (ins.readByte()&0xff); ins.readByte(); this.londir = new String(__strbuf);
 
        this.altitude = ins.readFloat();
 
        this.eastings = ins.readFloat();
 
        this.northings = ins.readFloat();
 
    }
 
    public gps_package.gps_t copy()
    {
        gps_package.gps_t outobj = new gps_package.gps_t();
        outobj.timestamp = this.timestamp;
 
        outobj.lat = this.lat;
 
        outobj.latdir = this.latdir;
 
        outobj.lon = this.lon;
 
        outobj.londir = this.londir;
 
        outobj.altitude = this.altitude;
 
        outobj.eastings = this.eastings;
 
        outobj.northings = this.northings;
 
        return outobj;
    }
 
}

